<?php 

//If not user for security purpose
if ( ! defined( 'ABSPATH' ) ) exit;

// Card Desinger admin class
class wd_card_designer_admin extends wd_card_designer_main {
	
	// admin construstor
	public function __construct() {
		
		$this->templates = array(
			'card-designer.php' => 'Designer Templates',
			);
		
		add_action( 'add_meta_boxes', array($this,'wd_card_designer_meta_box'));
		
		add_filter( 'theme_page_templates', array( $this, 'add_new_template' ));
		
		add_action('save_post', array($this,'wc_enable_card_save_meta' ));
		
		add_action( 'wp_loaded', array($this, 'w_card_admin_styles_scripts' ));

		add_shortcode('ext_clipart_filters', array($this, 'clipartshorcodefunction'));
		
		add_shortcode('ext_clipart_filtersb', array($this, 'clipartshorcodefunctionb'));

		add_filter('woocommerce_hidden_order_itemmeta', array($this,'hidden_meta'), 10, 1);

		add_action( 'admin_menu', array($this,'pdocs_register_my_custom_menu_page'));

		add_action( 'admin_footer', array($this,'remove_revision_menu'));

	}

	// hidden menu create in wordpress
	public function remove_revision_menu() { ?>
	<script type="text/javascript">
		(function ($) {
			$(document).ready(function () {
				$('div#adminmenuwrap li a').each(function (index) {
					if ($(this).text() == 'Wc Orders Page') $(this).remove();
				});
			});
		})(jQuery);
	</script>
	<?php }

	// add a mneu page for orders canvas
	public function pdocs_register_my_custom_menu_page() {
		add_submenu_page(
			'edit.php?post_type=wc_designer',
			__( 'Wc Orders Page', 'card-designer' ),
			__( 'Wc Orders Page', 'card-designer' ),
			'manage_options',
			'wc_orders',
			array($this,'books_ref_page_callback')
			);
	}
	
	// callaback for admin menu orders canvas
	public function books_ref_page_callback() { 
		
		if (isset($_GET["wc_pro_id"]) && $_GET['wc_pro_id'] != '') { ?>

		<div id="wp_body">
			
			<div class="wrap">
				
				<h1><?php echo _e('Card Designer Orders Listing', 'card-designer');?></h1>
				
				<div class="wc_main_order_listing">
					<div id="wc_order_ltabs">
						<ul id="ul-back">
							<li class="wc-tabsli">
								<a href="#tabs-1"><?php _e('Front Side', 'card-designer'); ?>
								</a>
							</li>
							<li class="wc-tabsli">
								<a href="#tabs-2"><?php _e('Back Side', 'card-designer'); ?>
								</a>
							</li>   
						</ul>
						
						<div id="tabs-1">
							<?php require_once( wd_card_designer_plguin_dir.'OrdersTemplate/order-template-front.php'); ?>
						</div>
						
						<div id="tabs-2">
							<?php require_once( wd_card_designer_plguin_dir.'OrdersTemplate/order-template-back.php'); ?>
						</div>
					</div>

					<script type="text/javascript">
						jQuery(function() {
							jQuery( "#wc_order_ltabs" ).tabs();
						});
					</script>
					
				</div>

			</div>
			
		</div>

		<?php }
	}

	// remove item meta from order edit page 
	public function hidden_meta($arr) {
		$arr[] = 'Order_log_user_back';
		$arr[] = 'Order_log_user_front';
		$arr[] = 'Order_guest_user_front';
		$arr[] = 'Order_guest_user_back';
		return $arr;
	}

	//clip art category wise listing shortcode
	public function clipartshorcodefunctionb() {

		$terms = get_terms( 'wc_designertex' ); 
		$term_ids = wp_list_pluck( $terms, 'term_id' );
		
		if ( !empty($terms) && ! is_wp_error($terms) ) { ?>
		<label><?php _e('Select Category','card-designer'); ?></span>
			<select id="ext_cat_listsb">
				
				<?php foreach ($terms as $term) { ?>
				<option value="<?php echo $term->term_id; ?>"><?php echo $term->name; ?></option>
				<?php } ?>
				
			</select>
			
			<?php } ?>

			<script>
				
				jQuery("#ext_cat_listsb").change(function() {
					clipartfiltringb(this.value);
				});
				function clipartfiltringb(id) {
					var ajaxurl = "<?php echo admin_url( 'admin-ajax.php'); ?>";
					var id = id;
					var condition = 'clipartextb';
					jQuery.ajax({
						url : ajaxurl,
						type : 'post',
						data : {
							action : 'sortactioneventb',
							condition :condition,
							id : id
						},
						beforeSend: function() {
							jQuery('#main_divdb').html("<img src='<?php echo wd_card_designer_url.'images/inssertcat.gif'?>'/>");
						},
						success : function( response ) {
							jQuery('#main_divdb').replaceWith( response );
                        	// alert(response);
                        }
                    });
				}
				

			</script>
			
			<?php 
			
			$args = array(
				'post_type' => 'wc_designer',
				'posts_per_page' => -1,
				'tax_query' => array(
					array(
						'taxonomy' => 'wc_designertex',
						'field'    => 'id',
						'terms'    => $term_ids,
						),
					),
				);

			$clipart = new WP_Query($args);

			if($clipart->have_posts()) : ?>    
			
			<ul id="main_divdb" class="ularts">	
				<?php while($clipart->have_posts()) : $clipart->the_post(); ?>
					<li class="liarts">
						<?php the_post_thumbnail("full", array("class" => "myclipb", "id" => "cliparts".get_the_id())); ?>
					</li>
				<?php endwhile; ?>
			</ul>
			
			<script>
				jQuery('img.myclipb').click(function() {
					fabric.Image.fromURL(document.getElementById(this.id).src, function(myImg) {
						var img1 = myImg.set({ left: 0, top: 0 ,width:150,height:150});
						canvasb.add(img1);
						canvas.renderAll();
						
					}); 
				});
			</script>

		<?php else: ?>

			<?php _e('No Cliparts kindly add some from admin', 'product-designer'); ?>
			
		<?php endif;
	}

	//clip art category wise listing shortcode
	public function clipartshorcodefunction() {

		$terms = get_terms( 'wc_designertex' ); 
		$term_ids = wp_list_pluck( $terms, 'term_id' );
		
		if ( !empty($terms) && ! is_wp_error($terms) ) { ?>
		<label><?php _e('Select Category','card-designer'); ?></span>
			<select id="ext_cat_lists">
				
				<?php foreach ($terms as $term) { ?>
				<option value="<?php echo $term->term_id; ?>"><?php echo $term->name; ?></option>
				<?php } ?>
				
			</select>
			
			<?php } ?>

			<script>
				
				jQuery("#ext_cat_lists").change(function() {
					clipartfiltring(this.value);
				});
				function clipartfiltring(id) {
					var ajaxurl = "<?php echo admin_url( 'admin-ajax.php'); ?>";
					var id = id;
					var condition = 'clipartext';
					jQuery.ajax({
						url : ajaxurl,
						type : 'post',
						data : {
							action : 'sortactionevent',
							condition :condition,
							id : id
						},
						beforeSend: function() {
							jQuery('#main_divd').html("<img src='<?php echo wd_card_designer_url.'images/inssertcat.gif'?>'/>");
						},
						success : function( response ) {
							jQuery('#main_divd').replaceWith( response );
						}
					});
				}
				

			</script>
			
			<?php 
			
			$args = array(
				'post_type' => 'wc_designer',
				'posts_per_page' => -1,
				'tax_query' => array(
					array(
						'taxonomy' => 'wc_designertex',
						'field'    => 'id',
						'terms'    => $term_ids,
						),
					),
				);

			$clipart = new WP_Query($args);

			if($clipart->have_posts()) : ?>    
			
			<ul id="main_divd" class="ularts">	
				<?php while($clipart->have_posts()) : $clipart->the_post(); ?>
					<li class="liarts">
						<?php the_post_thumbnail("full", array("class" => "myclip", "id" => "cliparts".get_the_id())); ?>
					</li>
				<?php endwhile; ?>
			</ul>
			
			<script>
				jQuery('img.myclip').click(function() {
					fabric.Image.fromURL(document.getElementById(this.id).src, function(myImg) {
						var img1 = myImg.set({ left: 0, top: 0 ,width:150,height:150});
						canvas.add(img1); 
					}); 
				});
			</script>

		<?php else: ?>

			<?php _e('No Cliparts kindly add some from admin', 'product-designer'); ?>
			
		<?php endif;
	}

	public function add_new_template( $posts_templates ) {
		
		$posts_templates = array_merge( $posts_templates, $this->templates );
		
		return $posts_templates;
	}

	// meta box for product designer templates
	public function wd_card_designer_meta_box() {

		// admin template manker metabox
		add_meta_box( 'w_card_designer_template',
			__('Card Designer Templates Design', 'card-designer'),
			array($this,'wcard_setting_desinger_callback'),
			'product','normal');

		add_meta_box( 'w_card_enable_customization',
			__('Enable Card Customization', 'card-designer'),
			array($this,'wcard_enable_customization_callback'),
			'product','side');

		add_meta_box( 'w_getorder_card_template',
			__('Card Orders', 'card-designer'),
			array($this,'wcard_customer_order_callback'),
			'shop_order','normal');
	}
	
	// callback metabox designer template callback
	public function wcard_setting_desinger_callback() {
		
		$post_id = get_the_ID(); ?>

		<div id="tabs">
			<ul id="ul-back">
				<li class="wc-tabsli">
					<a href="#tabs-1"><?php _e('Front Side', 'card-designer'); ?>
					</a>
				</li>
				<li class="wc-tabsli">
					<a href="#tabs-2"><?php _e('Back Side', 'card-designer'); ?>
					</a>
				</li>   
			</ul>
			
			<div id="tabs-1">
				<?php require_once( wd_card_designer_plguin_dir.'Templates/front-side-template.php'); ?>
			</div>
			
			<div id="tabs-2">
				<?php require_once( wd_card_designer_plguin_dir.'Templates/back-side-template.php'); ?>
			</div>
		</div>

		<script type="text/javascript">
			jQuery(function() {
				jQuery( "#tabs" ).tabs();
			});
		</script>
		
		<?php }

		public function wcard_enable_customization_callback() { 
			
			$post_id = '';

			if (isset($_GET['post'])) {
				$post_id = $_GET['post'];
			}

			$value = get_post_meta($post_id, 'wc_enable_cstomization', true);
			wp_nonce_field('wc_enable_customization_nonce_'.$post_id, 'wc_enable_cstomization_nonce'); ?>

			<section>
				<!-- Checbox Four -->
				<h3><?php _e('Enable for customization', 'product-designer'); ?></h3>
				<div class="checkboxFour">
					<input type="checkbox" value="1" <?php echo checked( get_post_meta($post_id, 'wc_enable_cstomization', true), 'enable') ?> id="checkboxFourInput" name="wc_enable_cstomization" />
					<label for="checkboxFourInput"></label>
				</div>
			</section>
			<script type="text/javascript">
				jQuery(document).ready( function($) {
					jQuery('.meta-box-sortables').sortable({
						disabled: true
					});

					jQuery('.postbox .hndle').css('cursor', 'pointer');
				});
			</script>

			<?php }

	//savinig the post meta of customization
			public function wc_enable_card_save_meta($post_id) {

				if (defined('DOING_AUTOSAVE') && DOING_AUTOSAVE) {
					return;
				}
				if (!isset($_POST['wc_enable_cstomization_nonce']) || !wp_verify_nonce($_POST['wc_enable_cstomization_nonce'], 'wc_enable_customization_nonce_'.$post_id)) {
					return;
				}
				if (!current_user_can('edit_post', $post_id)) {
					return;
				}

				$subcheck = (isset($_POST['wc_enable_cstomization'])) ? "enable" : "";
				if (isset($subcheck)) {
					update_post_meta($post_id, 'wc_enable_cstomization', $subcheck);
				} else {
					delete_post_meta($post_id, 'wc_enable_cstomization');
				}
			}


	// --------------------------------------------------- //
	// --------Meta box callback for admin order---------- //
	// --------------------------------------------------- //

			public function wcard_customer_order_callback() {

				$post_id = get_the_ID(); 

				$order = wc_get_order( $post_id );

				$items = $order->get_items(); ?>

				<table class="wp-list-table widefat fixed striped posts">
					<thead>
						<tr>
							<td><?php echo _e('Item ID', 'card-designer'); ?></td>
							<td><?php echo _e('Item Thumbnail', 'card-designer'); ?></td>
							<th><?php echo _e('Item Name', 'card-designer'); ?></th>
							<th><?php echo _e('View Canvas', 'card-designer'); ?></th>
						</tr>
					</thead>
					<tbody>
						
						<?php foreach ($items as $key => $product ) { ?>

						<tr>
							<td><?php echo $key; ?></td>
							<td><?php echo get_the_post_thumbnail( $product['product_id'], array( 40, 40) ); ?></td>
							<td><?php echo get_the_title( $product['product_id'] ); ?></td>
							<td>
								<a target="_blank" href=<?php echo "edit.php?post_type=wc_designer&page=wc_orders&wc_pro_id=".$product['product_id'].'&wc_item_id='.$key; ?>>
									View Canvas
								</a>
							</td>
						</tr>

						<?php } ?>
						
					</tbody>
				</table>

				<?php }


	// admin style and css
				public function w_card_admin_styles_scripts() { 

					wp_enqueue_script('jquery');
					wp_enqueue_script( 'wcard-fabric-js', plugins_url( 'scripts/fabric.min.js', __FILE__ ), false );
					wp_enqueue_script( 'wcard-defualt-tabs-js', plugins_url( 'scripts/jquery-ui.js', __FILE__ ), false );
					wp_enqueue_style( 'wcard-defualt-tabs-css', plugins_url( 'styles/jquery-ui.css', __FILE__ ), false );
					wp_enqueue_style( 'wcard-admin-style', plugins_url( 'styles/font-awesome.min.css', __FILE__ ), false );
					wp_enqueue_style( 'wcard-customfont-style', plugins_url( 'styles/custom-font.css', __FILE__ ), false );
					wp_enqueue_script ( 'wc_admin_font_loads', plugins_url('scripts/fontfaceobserver.js', __FILE__), false );
					wp_enqueue_script( 'wcard-sssres-js', plugins_url( 'scripts/resposive_popup.js', __FILE__ ), false, '1.0.2' );
					wp_enqueue_script( 'wc-spectrum-js', plugins_url( 'scripts/spectrum.js', __FILE__ ), false );
					wp_enqueue_style( 'wc-spectrum-style', plugins_url( 'styles/spectrum.css', __FILE__ ), false );
				}

			} new wd_card_designer_admin();
