<?php 

//If not user for security purpose
if ( ! defined( 'ABSPATH' ) ) exit;

// Card Desinger front class
class wd_card_designer_front extends wd_card_designer_main {
	
	// constructor front end
	public function __construct() {

		add_action('woocommerce_after_add_to_cart_form',array($this,'wcard_customize_product_button'));
		
		add_filter( 'page_template', array($this,'wcard_designer_register_template' ));
		
		add_action( 'wp_loaded', array( $this, 'w_card_front_styles_scripts' ));

		add_shortcode('front_clipart_code', array($this, 'front_shortcode_arts'));

		add_action('woocommerce_before_add_to_cart_button', array($this,'savedataiamgebase64' ));

		add_filter('woocommerce_add_cart_item_data', array($this,'addProductToCart'), 10, 2 );

		add_filter('woocommerce_get_item_data', array($this,'getting_car_item_data'), 10, 2 );

		add_action('woocommerce_add_order_item_meta',  array($this, 'add_order_item_meta') , 10, 2 );
	}

	//function to get item/fields for cart
	public function addProductToCart( $cart_item_data, $product_id ) {

		if(isset( $_REQUEST['wc_product_designerpic']) && !empty($_REQUEST['wc_product_designerpic'])) {

			$cart_item_data[ 'wc_product_designerpic' ] = $_REQUEST['wc_product_designerpic'];

		}

		return $cart_item_data;
	}

	//dispaly option fields in cart
	public function getting_car_item_data( $cart_data, $carti = null ) {

		$custom_items = array();

		if( !empty( $cart_data ) ) {

			$custom_items = $cart_data;
		}

		if( isset( $carti['wc_product_designerpic']) &&  !empty($carti['wc_product_designerpic'])) {

			$check=true;
			foreach ($carti['wc_product_designerpic'] as $cartival) {
				if($check){
				$custom_items[] = array( 'name' => 'Front Design',
					'value' =>  '<img style="width:50px;" src="'.$cartival.'"/>');
				$check=false;
			}
			else{
					$custom_items[] = array( 'name' => 'Back Design',
					'value' =>  '<img style="width:50px;" src="'.$cartival.'"/>');

			}

		}

		}

		return $custom_items;
	}

	//adding cart data as an image
	public function savedataiamgebase64() {

		global $post;

		$allow_design = get_post_meta($post->ID, 'wc_enable_cstomization', true);	

		if(isset($allow_design) && $allow_design == "enable") {

			if (isset($_POST["imagedataurlbase64"]) && !empty($_POST["imagedataurlbase64"])) { 

				if(is_user_logged_in()) {

					$current_user = wp_get_current_user(); ?>

					<div class="wc_design_images">

						<h4><?php _e('Card Design', ''); ?></h4>
						
						<?php 

						$aa = 1;

						foreach ($_POST["imagedataurlbase64"] as $value_data ) {

							$imagedata = $value_data; 

							$data = $imagedata;

							list($type, $data) = explode(';', $data);

							list(,$extension) = explode('/',$type);

							list(, $data) = explode(',', $data);

							$fileName = uniqid().'.'.$extension;

							$data = base64_decode($data);

							file_put_contents(wd_card_designer_plguin_dir.'images/'.$fileName, $data);

							update_post_meta($post->ID, 'wc_design_file_'.$aa.'-log-'.$current_user->ID, $fileName); 

							$file_post_meta = get_post_meta($post->ID, 'wc_design_file_'.$aa.'-log-'.$current_user->ID, true);

							$path = wd_card_designer_url.'images/'.$file_post_meta; ?>

							<a class="wc_fancybox" href="<?php echo $path; ?>">
								<img class="fancy_box_self_style" width="100px" src="<?php echo $path; ?>">
							</a>

							<input type="hidden" name="wc_product_designerpic[]" id="wc_product_designerpic" value="<?php echo $path; ?>"/>	
							
							<?php $aa++; } ?>

						</div>

						<?php } else { ?>
						
						<div class="wc_design_images">
							
							<h4><?php _e('Card Design', ''); ?></h4>

							<?php 

							$current_user_ip = $_SERVER['REMOTE_ADDR'];

							$aa = 1;

							foreach ($_POST["imagedataurlbase64"] as $value_data ) {

								$imagedata = $value_data; 

								$data = $imagedata;

								list($type, $data) = explode(';', $data);

								list(,$extension) = explode('/',$type);

								list(, $data) = explode(',', $data);

								$fileName = uniqid().'.'.$extension;

								$data = base64_decode($data);

								file_put_contents(wd_card_designer_plguin_dir.'images/'.$fileName, $data);

								update_post_meta($post->ID, 'wc_design_file_'.$aa.'-guest-'.$current_user_ip, $fileName); 

								$file_post_meta = get_post_meta($post->ID, 'wc_design_file_'.$aa.'-guest-'.$current_user_ip, true);

								$path = wd_card_designer_url.'images/'.$file_post_meta; ?>

								<a class="wc_fancybox" href="<?php echo $path; ?>">
									<img class="fancy_box_self_style" width="100px" src="<?php echo $path; ?>">
								</a>

								<input type="hidden" name="wc_product_designerpic[]" id="wc_product_designerpic" value="<?php echo $path; ?>"/>	

								<?php $aa++; } ?>

							</div>

							<?php } ?>

							<script type="text/javascript">
								jQuery(document).ready(function() {
									jQuery('.wc_fancybox').fancybox();
								});
							</script>

							<?php } }
						}	

	//adding order meta in fields for retriving in admin order datail
						public function add_order_item_meta( $item_id, $cart_item ) { 


							if(isset($cart_item['wc_product_designerpic'])) {

								$imagedata = $cart_item['wc_product_designerpic'];

								if(isset($imagedata) && !empty($imagedata)) {
									$check=true;
									foreach ($imagedata as $d_images) {
										if($check){
											wc_add_order_item_meta($item_id, 'Front Design', '<a target="blank" href="'.$d_images.'" ><img width="50px" src="'.$d_images.'"></a> <br> <a target="blank" href="'.$d_images.'" download>Download</a><br>');
											//wc_add_order_item_meta($item_id, 'Click here', '<a target="blank" href="'.$d_images.'" download>Download</a>');
											$check=false;
										}
										else{
											wc_add_order_item_meta($item_id, 'Back Design', '<a target="blank" href="'.$d_images.'" ><img width="50px" src="'.$d_images.'"></a> <br> <a target="blank" href="'.$d_images.'" download>Download</a>');
											//wc_add_order_item_meta($item_id, 'Click here', '<a target="blank" href="'.$d_images.'" download>Download</a>');
										}
									}

									if(is_user_logged_in()) {

										$cart_item['product_id'];

										$current_user = wp_get_current_user();

										$front_side = get_post_meta($cart_item['product_id'], 'wc_front_side_user'.'-'.$current_user->ID, true);

										$back_side = get_post_meta($cart_item['product_id'], 'wc_back_side_user'.'-'.$current_user->ID, true);

										if(!empty($front_side)) {

											wc_add_order_item_meta($item_id, 'Order_log_user_front', $front_side);

										}

										if(!empty($back_side)) {

											wc_add_order_item_meta($item_id, 'Order_log_user_back', $back_side);
										}

									} else {

										$cart_item['product_id'];

										$current_user_ip = $_SERVER['REMOTE_ADDR'];

										$front_side = get_post_meta($cart_item['product_id'], 'wc_front_side_user'.'_'.$current_user_ip, true);

										$back_side = get_post_meta($cart_item['product_id'], 'wc_back_side_user'.'_'.$current_user_ip, true);

										if(!empty($front_side)) {

											wc_add_order_item_meta($item_id, 'Order_guest_user_front', $front_side);

										}

										if(!empty($back_side)) {

											wc_add_order_item_meta($item_id, 'Order_guest_user_back', $back_side);
										}
									}

								}

							}
						}

	// main designer cliparts
						public function front_shortcode_arts () {
							$terms = get_terms( 'wc_designertex' ); 
							$term_ids = wp_list_pluck( $terms, 'term_id' );

							if ( !empty($terms) && ! is_wp_error($terms) ) { ?>
							<label><?php _e('Select Category','card-designer'); ?></span>
								<select id="selectfront_arts">
									<?php foreach ($terms as $term) { ?>
									<option value="<?php echo $term->term_id; ?>"><?php echo $term->name; ?></option>
									<?php } ?>
								</select>
								<?php } ?>

								<script type="text/javascript">
									jQuery("#selectfront_arts").change(function() {
										front_shortcode(this.value);
									});
									function front_shortcode(id) {
										var ajaxurl = "<?php echo admin_url( 'admin-ajax.php'); ?>";
										var id = id;
										var condition = 'front_artcondition';
										jQuery.ajax({
											url : ajaxurl,
											type : 'post',
											data : {
												action : 'front_artaction',
												condition :condition,
												id : id
											},
											beforeSend: function() {
												jQuery('#front_artdiv').html("<img src='<?php echo wd_card_designer_url.'images/inssertcat.gif'?>'/>");
											},
											success : function( response ) {
												jQuery('#front_artdiv').replaceWith( response );
											}
										});
									}
								</script>

								<?php 

								$args = array(
									'post_type' => 'wc_designer',
									'posts_per_page' => -1,
									'tax_query' => array(
										array(
											'taxonomy' => 'wc_designertex',
											'field'    => 'id',
											'terms'    => $term_ids,
											),
										),
									);

								$clipart = new WP_Query($args);

								if($clipart->have_posts()) : ?>    
								<ul id="front_artdiv" class="ularts">	
									<?php while($clipart->have_posts()) : $clipart->the_post(); ?>
										<li class="liarts">
											<?php the_post_thumbnail("full", array("class" => "frontclass", "id" => "cliparts".get_the_id())); ?>
										</li>
									<?php endwhile; ?>
								</ul>
							<?php else: ?>

								<?php _e('No Cliparts kindly add some from admin', 'product-designer'); ?>

							<?php endif;?>

							<script type="text/javascript">
								jQuery('img.frontclass').click(function() {
									fabric.Image.fromURL(document.getElementById(this.id).src, function(myImg) {
										var img1 = myImg.set({ left: 100, top: 100 ,width:myImg.width,height:myImg.height});
										canvas.add(img1); 
									}); 
									jQuery('.my_modal1_close').click();
								});
							</script>
							<?php }

	// Calling page template
							public function wcard_designer_register_template( $page_template ) {

								if ( is_page( 'wc-designer' ) ) {

									$page_template = dirname( __FILE__ ) . '/Templates/card-designer.php';

								} 
								return $page_template;
							}

    // add to customization designer
							public function wcard_customize_product_button() {

								global $post;

								$enable_card_editing = get_post_meta($post->ID, 'wc_enable_cstomization', true); 

								if(!empty($enable_card_editing) && $enable_card_editing  == 'enable') { 

									$wc_designer_idd = (int)get_option("wc_designer_id");
									$page_link = get_permalink($wc_designer_idd);

									?>

									<form method="POST" action="<?php echo esc_url($page_link); ?>?postid=<?php echo $post->ID;?>">

										<input type="hidden" value="<?php echo $post->ID; ?>" name="wc_id" />
										<input id="enabl_wc_c" type="submit" value="<?php _e('Customize Card', 'card-designer'); ?>" />

									</form>



									<?php } }

	// front scripts
									public function w_card_front_styles_scripts() { 

										$active_theme = wp_get_theme();

										if ($active_theme->get( 'Name' ) == 'Flatsome') 
										{
											wp_enqueue_style( 'wcard-front-style_flatsome', plugins_url( 'styles/flatsome_style.css', __FILE__ ), false );
											wp_enqueue_style( 'wcard-front-style_flatsomee', 'https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.2.0/css/all.min.css' );
											




										}
										if ($active_theme->get( 'Name' ) == 'Divi') 
										{
											wp_enqueue_style( 'wcard-front-style_flatsomee', 'https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.2.0/css/all.min.css' );
										}
										if ($active_theme->get( 'Name' ) == 'Avada') 
										{
											wp_enqueue_style( 'wcard-front-style_avada', plugins_url( 'styles/avada_style.css', __FILE__ ), false );
										}

										wp_enqueue_script('jquery');

										wp_enqueue_script( 'wcard-responsivepopup-js', plugins_url( 'scripts/resposive_popup.js', __FILE__ ), false , '1.0.2');

										wp_enqueue_script( 'wcard-fabric-js', plugins_url( 'scripts/fabric.min.js', __FILE__ ), false );

										wp_enqueue_style( 'wcard-front-style', plugins_url( 'styles/frontend-style.css', __FILE__ ), false );

										wp_enqueue_script( 'wc-spectrum-js', plugins_url( 'scripts/spectrum.js', __FILE__ ), false );

										wp_enqueue_style( 'wc-spectrum-style', plugins_url( 'styles/spectrum.css', __FILE__ ), false );

										wp_enqueue_style( 'wcard-customfont-style', plugins_url( 'styles/custom-font.css', __FILE__ ), false );

										wp_enqueue_script( 'wc_admin_font_loads', plugins_url('scripts/fontfaceobserver.js', __FILE__), false );

										wp_enqueue_script( 'wc-fancybox-js', plugins_url( 'scripts/jquery.fancybox.js', __FILE__ ), false );

										wp_enqueue_style( 'wc-fancy-style', plugins_url( 'styles/jquery.fancybox.css', __FILE__ ), false );

									} 	

								} new wd_card_designer_front(); 




